#include "fifosshcreator.h"

void main (int argc, char *args[]){
	char c[1]; //utilizado para la pausa
	
	/*descriptores de archivo para el ingreso de comandos a clientes ssh*/
	int 	fdi1, fdi2, fdi3,  fdi4; 
	
	pthread_t tcmd1, tcmd2, tcmd3, tcmd4; //identificadores de hebras

	/*comandos a ejecutar:
	 *Nota: es necesario añadir \n\0 
	 *al final de al cadena para simular
	 *el Enter e indicar el fin del string
	 * */
	char cmd1[100]="ls -la\n\0";
	char cmd2[100]="hostname \n\0";
	char cmd3[100]="ps aux\n\0";
	char cmd4[100]="netstat\n\0";


	/*Estableciemiento de conecciones e ingreso de parametros nesesarios
	 *
	 * Argumentos necesarios:
	 *
	 *tid1: Puntero a una hebra.
	 *userName: Nombre del usuario para conectarse al servidor ssh.
	 *hostName: Dirección IP del servidor ssh.
	 *fifoIn: Puntero a un fifo para recibir datos.
	 *fifoOut: Puntero a un fifo para enviar datos.
	 *consoleTitle: Nombre de la consola.
	 *consoleGeometry: Detalles del aspecto de la consola.
	 *namelog: Prefijo para un archivo .log
	 * */
	if((fdi1=start_connection(&tcmd1, args[1], args[2], "fin_cmd1", "fout_cmd1", "ls", NULL,"cmd_ls"))<0){
		perror("start_connection");
	}

	if((fdi2=start_connection(&tcmd2, args[1], args[2], "fin_cmd2", "fout_cmd2", "hostname", "71x9-0-355","cmd_hostname"))<0){
		perror("start_connection");
	}

	if((fdi3=start_connection(&tcmd3, args[1], args[2], "fin_cmd3", "fout_cmd3", "ps", NULL,"cmd_ps"))<0){
		perror("start_connection");
	}

	if((fdi4=start_connection(&tcmd4, args[1], args[2], "fin_cmd4", "fout_cmd4", "netstat", NULL,"cmd_netstat"))<0){
		perror("start_connection");
	}

	/*Ingreso de los comando a traves de los descriptores 
	 *de archivo fdi#
	 * */
	write(fdi1, cmd1, sizeof(cmd1));
	write(fdi2, cmd2, sizeof(cmd2));
	write(fdi3, cmd3, sizeof(cmd4));
	write(fdi4, cmd4, sizeof(cmd4));

	//sirve para evitar el cierre inmediato de las consolas
	sleep(5);
	printf("presione ENTER para continuar...\n");
	scanf("%c",c);

	/*instruccion de cierre
	 *Nota: se envia un string 'exit\n'
	 * */
	write(fdi1, MSG_EXIT, SIZEOF_EXIT);
	write(fdi2, MSG_EXIT, SIZEOF_EXIT);
	write(fdi3, MSG_EXIT, SIZEOF_EXIT);
	write(fdi4, MSG_EXIT, SIZEOF_EXIT);


	/*espera por el termino de las hebras
	 *
	 * Nota: las hebras también son teminadas cuando 
	 * se envia un 'exit\n'
	 * */

	pthread_join(tcmd1,NULL);
	pthread_join(tcmd2,NULL);
	pthread_join(tcmd3,NULL);
	pthread_join(tcmd4,NULL);

	unlink("fin_cmd1");
	unlink("fin_cmd2");
	unlink("fin_cmd3");
	unlink("fin_cmd4");
	unlink("fout_cmd1");
	unlink("fout_cmd2");
	unlink("fout_cmd3");
	unlink("fout_cmd4");
}
